
#include <SimpleModbusSlave.h>
#define ID_MODBUS     1	            // ID address ModBus RTU Device
#define Relay1	      5             // реле №1
#define Relay2	      6             // реле №2
#define Relay3	      7             // реле №3
#define Relay4	      8             // реле №4
#define Relay5	      11            // реле №5
#define Relay6	      10            // реле №6
#define Relay7	      12            // реле №7
#define Relay8	      9             // реле №8
int LedState=LOW;                      // выключаем светодиод 
long previousMillis = 0;               // обнуляем счетчик милисек. 
long interval = 1000;                  // время моргания 1 сек. можно другое 

enum {        
	RL0,    // реле 1
	RL1,	// реле 2
	RL2,    // реле 3
	RL3,    // реле 4
        RL4,    // реле 5
        RL5,    // реле 6
        RL6,    // реле 7
        RL7,    // реле 8
	RS1,    // сенсор 1
	RS2,    // сенсор 2
	RS3,    // сенсор 3
	RS4,    // сенсор 4
	RS5,    // сенсор 5
        RS6,    // сенсор 6
        RS7,    // сенсор 7
        RS8,    // сенсор 8
	MB_REGS		              // кол-во регистров
};
//unsigned int tab_reg[MB_REGS];
uint16_t tab_reg[MB_REGS];
int count = 0;

void setup() 
{
    // 2й- управляющий пин max485 (0 и 1 - не использ.)
	modbus_configure(19200, ID_MODBUS, 2, MB_REGS, tab_reg); 
	pinMode(Relay1, OUTPUT);                          // установка вых для реле №1 
        pinMode(Relay2, OUTPUT);                          // установка вых для реле №2
        pinMode(Relay3, OUTPUT);                          // установка вых для реле №3
        pinMode(Relay4, OUTPUT);                          // установка вых для реле №4
        pinMode(Relay5, OUTPUT);                          // установка вых для реле №5
        pinMode(Relay6, OUTPUT);                          // установка вых для реле №6
        pinMode(Relay7, OUTPUT);                          // установка вых для реле №7
        pinMode(Relay8, OUTPUT);                          // установка вых для реле №8
	
  }
void NewRelay()
{
 digitalWrite(Relay1, tab_reg[RL0]);                      //выведем значения регистров на реле
 digitalWrite(Relay2, tab_reg[RL1]);
 digitalWrite(Relay3, tab_reg[RL2]);
 digitalWrite(Relay4, tab_reg[RL3]);	
 digitalWrite(Relay5, tab_reg[RL4]);	
 digitalWrite(Relay6, tab_reg[RL5]);	
 digitalWrite(Relay7, tab_reg[RL6]);	
 digitalWrite(Relay8, tab_reg[RL7]);							
}

void NewSens()
{
 tab_reg[RS1] = digitalRead(3);                            //считываем сенсоры.обновляем значения регисторв
 tab_reg[RS2] = digitalRead(4);
 tab_reg[RS3] = digitalRead(15);
 tab_reg[RS4] = digitalRead(14);	
 tab_reg[RS5] = digitalRead(18);	
 tab_reg[RS6] = digitalRead(19);
 tab_reg[RS7] = digitalRead(16);
 tab_reg[RS8] = digitalRead(17);				
}

void loop ()
{
	NewSens();
        modbus_update();	// Обмен с мастером
	NewRelay();
unsigned long currentMillis = millis();         // проверяем не прошел ли нужный интервал, если прошел то
  if(currentMillis - previousMillis > interval) { // сохраняем время последнего переключения
    previousMillis = currentMillis;               // если светодиод не горит, то зажигаем, и наоборот
    if (LedState == LOW)
      LedState = HIGH;
    else
      LedState = LOW;
    digitalWrite(13, LedState);              // устанавливаем состояния выхода, чтобы включить или выключить светодиод
  }
  }
